--[[
==myHonor==
By Smokey aka Mahuatahu on Earthen Ring Horde US

==Version==	
1.1.1

==To do list==
2.) (maybe?) own GUI instead of data broker --too lazy now, convenient when built into Titan Panel or FuBar
3.) Honor, and conquest goals.
==Changelog==
1.2.1 -- Fixed a couple problems with Session honor getting reset on world entrance, honor per hour modifications..
1.2.0 -- Fixed couple TOC version stuffs, added Honor Per Hour!
1.1.1 -- Changed to fix honor value on load.
1.1.0 -- Released to public, finally a "finished product"
1.0 -- Just made
--]]


-- Short configuration
local useSI = true					--[[	true: SI-units, e.g. 3.2k instead of 3230			]]
-- Configuration end

local suffixes = {
	"Total Honor Pts",
	"Honor Today",
	"BG Honor",
	"Honor",
}

local function siUnits(value)
	if(not useSI) then
		return value
	elseif(not value or value == 0) then
		return 0
	elseif(value >= 10^3) then
		return ("%.1fk"):format(value / 10^3)
	elseif(value >= 10^6) then
		return ("%.1fm"):format(value / 10^6)
	else
		return value
	end
end

local function texturizeIcon(arg1)
	return format("|T%s:15:15:0:0|t", type(arg1) == "number" and GetItemIcon(arg1) or arg1)
end

-- Initializing the object and frame
local honorIcon = "Interface\\PVPFrame\\PVP-Currency-"..UnitFactionGroup("player")
--local arenaIcon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]]

local OnEvent = function(self, event, ...) self[event](self, event, ...) end
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("myHonor", {
	type = "data source",
	text = "0 total",
	value = "0",
	icon = honorIcon,
	suffix = " Total Honor Pts",
})
local frame = CreateFrame"Frame"

-- [[    Update the display !    ]] --
local session, total, startTime
local startHonor, isBG
local HonorGained, SessionHonor, StartingHonor, BGHonor, LastBG, HonorBefore = 0, 0, 0, 0, 0, 0, 0, 0, 0
local HonorGained_InBG = 0
local BGCount = 0
local AvgHonor = 0
local EnteredBG = 0
local InBG = 0
local FinallyLoaded = nil


function frame:CURRENCY_DISPLAY_UPDATE()
	local displ = myHonor.displ
	local value

HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
SessionHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
if (InBG==1) then
BGHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - HonorBefore
end
if (BGCount>0) then
AvgHonor = HonorGained_InBG / BGCount   
end

	if(displ == 4) then
		if(isBG) then
			value = BGHonor.. " | "..siUnits(SessionHonor).." | "
		elseif(SessionHonor > 0) then
			value = siUnits(SessionHonor).." | "
		else
			value = ""
		end
		value = value..HonorGained
	--elseif(displ == 4) then
	--	value =  arena
	elseif(displ == 3) then
		value = BGHonor
	elseif(displ == 2) then
		value = siUnits(SessionHonor)
	else
		value = HonorGained
	end
	dataobj.value = value
	dataobj.text = value.." "..dataobj.suffix
end

--[[   Initialize all variables    ]] --
function frame:PLAYER_ENTERING_WORLD()
	if(not myHonor) then
	myHonor = {}
	end
	startTime = time()
    HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  ZoneInfo = (select(2, IsInInstance()))
	  InBG = 0
	  if (ZoneInfo == "pvp") then
	     InBG = 1 --In a battleground
 	     BGCount = BGCount + 1
	     HonorGained_InBG = HonorGained_InBG + BGHonor
	     LastBG = BGHonor
	     BGHonor = 0
         HonorBefore = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  else
	     InBG = 0 --Not in a battleground
	  end
	--if(cargoHonor.displ == 4) then dataobj.icon = [[Interface\PVPFrame\PVP-ArenaPoints-Icon]] end
	--self:CHAT_MSG_COMBAT_HONOR_GAIN()
	if (FinallyLoaded==nil) then
	self:CheckHonor()
	end
end

frame:SetScript("OnEvent", OnEvent)
--frame:RegisterEvent"CHAT_MSG_COMBAT_HONOR_GAIN"
frame:RegisterEvent"PLAYER_ENTERING_WORLD"
--frame:RegisterEvent"COMBATLOG_HONORAWARD"
--frame:RegisterEvent"PLAYER_PVP_KILLS_CHANGED"
frame:RegisterEvent"CURRENCY_DISPLAY_UPDATE"

-- [[   The tooltip  ]] --
function dataobj.OnTooltipShow(tooltip)

	 local hc, InBGtext, pname, rname, fname = 0, 0, 0, 0, 0
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
     if (InBG==1) then
     InBGtext = RedText(GetZoneText())
     else 
     InBGtext = GreenText("Not currently in BG")
     end
	-- Honor Stats
	local perHour
	if (SessionHonor>0) then
	if(startTime) then perHour = SessionHonor/((time()-startTime)/3600) end
	else
	perHour = 0
	end
	--xpPerHour = sessionXP / sessionTime * 3600
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	-- Arena points
	--local arena = GetArenaCurrency()
	--if(arena > 0) then
	--	tooltip:AddDoubleLine("Arena points:", arena.." "..texturizeIcon(arenaIcon), 1,1,1, 0,1,0)
	--end
	tooltip:AddLine(pname.." - "..rname.." ("..fname..")")
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(myHonor_TT_STATUS,InBGtext)
	tooltip:AddDoubleLine(myHonor_TT_SESSIONPTS,Should_I_Be_Red(SessionHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALPTS,GetHighText(StartingHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALHKS,GetHighText(hc))
	tooltip:AddLine(" ")
	tooltip:AddLine("----------------------------------")
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(GetHighText(myHonor_TT_BGSTATS))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(myHonor_TT_LASTBG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(myHonor_TT_BGHONOR,Should_I_Be_Red(BGHonor))
	tooltip:AddDoubleLine(myHonor_TT_AVGHONOR,Should_I_Be_Red(format("%d",AvgHonor)))
	tooltip:AddDoubleLine(myHonor_TT_BGCOUNT,Should_I_Be_Red(BGCount))
	tooltip:AddDoubleLine(myHonor_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddLine(" ")
	--tooltip:AddLine("Click to toggle display")
	tooltip:AddLine("Right-click to open PvP-Panel")
	tooltip.updateFunction = dataobj.OnTooltipShow
end

function dataobj.OnClick(self, button)
	if(button == "RightButton") then
		TogglePVPFrame()
	else
		--myHonor.displ = (myHonor.displ == 4 and 1) or (myHonor.displ and myHonor.displ+1) or 2
		local displ = myHonor.displ
		--if(displ == 4) then
		--	dataobj.icon = arenaIcon
		--else
		if(displ == 4) then
			dataobj.icon = honorIcon
		end
		dataobj.suffix = suffixes[displ]
		frame:CURRENCY_DISPLAY_UPDATE()
	end
end

function GreenText(text)

	if (text) then
		return "|cff00ff00"..text.."|r"
	end 

end

function RedText(text)

	if (text) then
		return "|cffff0000"..text.."|r"
	end 

end

function BlueText(text)

	if (text) then
		return "|cff0000ff"..text.."|r"
	end 

end

function GetHighText(text)

	if (text) then
		return "|cffffffff"..text.."|r"
	end

end

function Should_I_Be_Red(text)
	if (text) then
		if (format("%d",text)=="0") then
			return RedText(text);
		else
			return GreenText(text);
		end
	end
end

function frame:CheckHonor()

dataobj.value = HonorGained
StartingHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
FinallyLoaded = true

end
